SimpleFeature (BioJava-1.5-beta API)
Keywords: org.biojava.bio.seq.impl.SimpleFeature class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.biojava.bio.seq.impl
Class SimpleFeature

    java.lang.Object
      org.biojava.utils.AbstractChangeable
          org.biojava.bio.seq.impl.SimpleFeature

All Implemented Interfaces:
  Serializable, Annotatable, Feature, FeatureHolder, RealizingFeatureHolder, Changeable

Direct Known Subclasses:
  SimpleStrandedFeature

    public class SimpleFeature

extends AbstractChangeable
implements Feature, RealizingFeatureHolder, Serializable

A no-frills implementation of a feature.

Author:
  Matthew Pocock, Thomas Down, Kalle N�slund, Paul Seed, Len Trigg
See Also:
  `SimpleRichFeature`, Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from interface org.biojava.bio.seq.Feature
`Feature.ByLocationComparator, Feature.Template`

Nested classes/interfaces inherited from interface org.biojava.bio.seq.FeatureHolder
`FeatureHolder.EmptyFeatureHolder`

Nested classes/interfaces inherited from interface org.biojava.bio.Annotatable
`Annotatable.AnnotationForwarder`

Nested classes/interfaces inherited from interface org.biojava.bio.seq.FeatureHolder
`FeatureHolder.EmptyFeatureHolder`

Field Summary

Fields inherited from interface org.biojava.bio.seq.Feature
`byLocationOrder, LOCATION, PROPERTY_DATA_KEY, SOURCE, SOURCETERM, TYPE, TYPETERM`

Fields inherited from interface org.biojava.bio.seq.FeatureHolder
`EMPTY_FEATURE_HOLDER, FEATURES, SCHEMA`

Fields inherited from interface org.biojava.bio.Annotatable
`ANNOTATION`

Fields inherited from interface org.biojava.bio.seq.FeatureHolder
`EMPTY_FEATURE_HOLDER, FEATURES, SCHEMA`

Constructor Summary
`SimpleFeature(Sequence sourceSeq, FeatureHolder parent, Feature.Template template)` Create a `SimpleFeature` on the given sequence.

Method Summary
`boolean` | `containsFeature(Feature f)` Check if the feature is present in this holder.
`int` | `countFeatures()` Count how many features are contained.
`Feature` | `createFeature(Feature.Template temp)` Create a new Feature, and add it to this FeatureHolder.
`boolean` | `equals(Object o)`
`protected boolean` | `featureHolderAllocated()` A utility function to find out if the feature holder delegate has been instantiated yet.
`Iterator` | `features()` Iterate over any child features which are held by this feature.
`protected void` | `fillTemplate(Feature.Template ft)`
`FeatureHolder` | `filter(FeatureFilter ff)` Query this set of features using a supplied `FeatureFilter`.
`FeatureHolder` | `filter(FeatureFilter ff, boolean recurse)` Return a new FeatureHolder that contains all of the children of this one that passed the filter fc.
`Annotation` | `getAnnotation()` Should return the associated annotation object.
`protected ChangeSupport` | `getChangeSupport(ChangeType ct)` Called to retrieve the ChangeSupport for this object.
`protected SimpleFeatureHolder` | `getFeatureHolder()` A utility function to retrieve the feature holder delegate, creating it if necessary.
`Location` | `getLocation()` The location of this feature.
`FeatureHolder` | `getParent()` Return the `FeatureHolder` to which this feature has been attached.
`FeatureFilter` | `getSchema()` Return a schema-filter for this `FeatureHolder`.
`Sequence` | `getSequence()` Return the `Sequence` object to which this feature is (ultimately) attached.
`String` | `getSource()` The source of the feature.
`Term` | `getSourceTerm()` An ontology term defining the source of this feature.
`SymbolList` | `getSymbols()` Return a list of symbols that are contained in this feature.
`String` | `getType()` The type of the feature.
`Term` | `getTypeTerm()` An ontology term defining the type of feature.
`int` | `hashCode()`
`Feature.Template` | `makeTemplate()` Create a new Template that could be used to generate a feature identical to this one.
`Feature` | `realizeFeature(FeatureHolder fh, Feature.Template templ)` Realize a feature template.
`void` | `removeFeature(Feature f)` Remove a feature from this FeatureHolder.
`void` | `setLocation(Location loc)` The new location for this feature.
`void` | `setSource(String source)` Change the source of the Feature.
`void` | `setSourceTerm(Term t)` Set the source ontology-term for this feature.
`void` | `setType(String type)` Change the type of this feature.
`void` | `setTypeTerm(Term t)` Set the type ontology-term for this feature.
`String` | `toString()`

Methods inherited from class org.biojava.utils.AbstractChangeable
`addChangeListener, addChangeListener, generateChangeSupport, hasListeners, hasListeners, isUnchanging, removeChangeListener, removeChangeListener`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.biojava.utils.Changeable
`addChangeListener, addChangeListener, isUnchanging, removeChangeListener, removeChangeListener`

Methods inherited from interface org.biojava.utils.Changeable
`addChangeListener, addChangeListener, isUnchanging, removeChangeListener, removeChangeListener`

Methods inherited from interface org.biojava.utils.Changeable
`addChangeListener, addChangeListener, isUnchanging, removeChangeListener, removeChangeListener`

Constructor Detail

### SimpleFeature

    public SimpleFeature(Sequence sourceSeq,
                         FeatureHolder parent,
                         Feature.Template template)

  Create a `SimpleFeature` on the given sequence. The feature is created underneath the parent `FeatureHolder` and populated directly from the template fields. However, if the template annotation is the `Annotation.EMPTY_ANNOTATION`, an empty `SimpleAnnotation` is attached to the feature instead.

  Parameters:
    `sourceSeq` - the source sequence
    `parent` - the parent sequence or feature
    `template` - the template for the feature

Method Detail

### getFeatureHolder

    protected SimpleFeatureHolder getFeatureHolder()

  A utility function to retrieve the feature holder delegate, creating it if necessary.

  Returns:
    the FeatureHolder delegate

### featureHolderAllocated

    protected boolean featureHolderAllocated()

  A utility function to find out if the feature holder delegate has been instantiated yet. If it has not, we may avoid instantiating it by returning some pre-canned result.

  Returns:
    true if the feature holder delegate has been created and false otherwise

### getChangeSupport

    protected ChangeSupport getChangeSupport(ChangeType ct)

  Description copied from class: `AbstractChangeable`
  Called to retrieve the ChangeSupport for this object.

  Your implementation of this method should have the following structure: ``

       ChangeSupport cs = super.getChangeSupport(ct);

       if(someForwarder == null && ct.isMatching(SomeInterface.SomeChangeType)) {
         someForwarder = new ChangeForwarder(...

         this.stateVariable.addChangeListener(someForwarder, VariableInterface.AChange);
       }

       return cs;

  It is usual for the forwarding listeners (someForwarder in this example) to be transient and lazily instantiated. Be sure to register & unregister the forwarder in the code that does the ChangeEvent handling in setter methods.

  Overrides:
    `getChangeSupport` in class `AbstractChangeable`

### getLocation

    public Location getLocation()

  Description copied from interface: `Feature`
  The location of this feature.

  The location may be complicated, or simply a range. The annotation is assumed to apply to all the region contained within the location.

  Specified by:
    `getLocation` in interface `Feature`
  Returns:
    a Location anchoring this feature

### setLocation

    public void setLocation(Location loc)
                     throws ChangeVetoException

  Description copied from interface: `Feature`
  The new location for this feature.

  The location may be complicated or simply a range. The annotation is assumed to apply to the entire region contained within the location. Any values returned from methods that rely on the old location must not be affected.

  Specified by:
    `setLocation` in interface `Feature`
  Parameters:
    `loc` - the new Location for this feature
  Throws:
    `ChangeVetoException` - if the location can't be altered

### getTypeTerm

    public Term getTypeTerm()

  Description copied from interface: `Feature`
  An ontology term defining the type of feature. This is optional, and will default to `OntoTools.ANY` in implementations which aren't ontology aware.

  Specified by:
    `getTypeTerm` in interface `Feature`

### getType

    public String getType()

  Description copied from interface: `Feature`
  The type of the feature.

  Specified by:
    `getType` in interface `Feature`
  Returns:
    the type of this sequence

### setType

    public void setType(String type)
                 throws ChangeVetoException

  Description copied from interface: `Feature`
  Change the type of this feature.

  Specified by:
    `setType` in interface `Feature`
  Parameters:
    `type` - new type String
  Throws:
    `ChangeVetoException` - if the type can't be altered

### setTypeTerm

    public void setTypeTerm(Term t)
                     throws ChangeVetoException

  Description copied from interface: `Feature`
  Set the type ontology-term for this feature. If this succeeds, it will generally also change the source name.

  Specified by:
    `setTypeTerm` in interface `Feature`
  Throws:
    `ChangeVetoException` - if changes are not allowed

### getSource

    public String getSource()

  Description copied from interface: `Feature`
  The source of the feature. This may be a program or process.

  Specified by:
    `getSource` in interface `Feature`
  Returns:
    the source, or generator

### getSourceTerm

    public Term getSourceTerm()

  Description copied from interface: `Feature`
  An ontology term defining the source of this feature. This is optional, and will default to `OntoTools.ANY` in implementations which aren't ontology aware.

  Specified by:
    `getSourceTerm` in interface `Feature`

### getParent

    public FeatureHolder getParent()

  Description copied from interface: `Feature`
  Return the `FeatureHolder` to which this feature has been attached. This will be a `Sequence` object for top level features, and a `Feature` object for features further down the tree.

  Specified by:
    `getParent` in interface `Feature`

### setSource

    public void setSource(String source)
                   throws ChangeVetoException

  Description copied from interface: `Feature`
  Change the source of the Feature.

  Specified by:
    `setSource` in interface `Feature`
  Parameters:
    `source` - the new source String
  Throws:
    `ChangeVetoException` - if the source can't be altered

### setSourceTerm

    public void setSourceTerm(Term t)
                       throws ChangeVetoException

  Description copied from interface: `Feature`
  Set the source ontology-term for this feature. If this succeeds, it will generally also change the source name.

  Specified by:
    `setSourceTerm` in interface `Feature`
  Throws:
    `ChangeVetoException` - if changes are not allowed

### getSequence

    public Sequence getSequence()

  Description copied from interface: `Feature`
  Return the `Sequence` object to which this feature is (ultimately) attached. For top level features, this will be equal to the `FeatureHolder` returned by `getParent`.

  Specified by:
    `getSequence` in interface `Feature`
  Returns:
    the ultimate parent Sequence

### getAnnotation

    public Annotation getAnnotation()

  Description copied from interface: `Annotatable`
  Should return the associated annotation object.

  Specified by:
    `getAnnotation` in interface `Annotatable`
  Returns:
    an Annotation object, never null

### getSymbols

    public SymbolList getSymbols()

  Description copied from interface: `Feature`
  Return a list of symbols that are contained in this feature.

  The symbols may not be contiguous in the original sequence, but they will be concatenated together in the resulting SymbolList.

  The order of the Symbols within the resulting symbol list will be according to the concept of ordering within the location object.

  If the feature location is modified then this does not modify any SymbolList produced by earlier invocations of this method.

  Specified by:
    `getSymbols` in interface `Feature`
  Returns:
    a SymbolList containing each symbol of the parent sequence contained within this feature in the order they appear in the parent

### countFeatures

    public int countFeatures()

  Description copied from interface: `FeatureHolder`
  Count how many features are contained.

  Specified by:
    `countFeatures` in interface `FeatureHolder`
  Returns:
    a positive integer or zero, equal to the number of features contained

### features

    public Iterator features()

  Description copied from interface: `Feature`
  Iterate over any child features which are held by this feature. The order of iteration MAY be significant for some types of Feature.

  Specified by:
    `features` in interface `Feature`
  Specified by:
    `features` in interface `FeatureHolder`
  Returns:
    an Iterator

### removeFeature

    public void removeFeature(Feature f)
                       throws ChangeVetoException

  Description copied from interface: `FeatureHolder`
  Remove a feature from this FeatureHolder.

  Specified by:
    `removeFeature` in interface `FeatureHolder`
  Throws:
    `ChangeVetoException` - if this FeatureHolder does not support feature removal or if the change was vetoed

### containsFeature

    public boolean containsFeature(Feature f)

  Description copied from interface: `FeatureHolder`
  Check if the feature is present in this holder.

  Specified by:
    `containsFeature` in interface `FeatureHolder`
  Parameters:
    `f` - the Feature to check
  Returns:
    true if f is in this set

### filter

    public FeatureHolder filter(FeatureFilter ff)

  Description copied from interface: `FeatureHolder`
  Query this set of features using a supplied `FeatureFilter`.

  Specified by:
    `filter` in interface `FeatureHolder`
  Parameters:
    `ff` - the `FeatureFilter` to apply.
  Returns:
    all features in this container which match `filter`.

### filter

    public FeatureHolder filter(FeatureFilter ff,
                                boolean recurse)

  Description copied from interface: `FeatureHolder`
  Return a new FeatureHolder that contains all of the children of this one that passed the filter fc. This method is scheduled for deprecation. Use the 1-arg filter instead.

  Specified by:
    `filter` in interface `FeatureHolder`
  Parameters:
    `ff` - the FeatureFilter to apply
    `recurse` - true if all features-of-features should be scanned, and a single flat collection of features returned, or false if just immediate children should be filtered.

### makeTemplate

    public Feature.Template makeTemplate()

  Description copied from interface: `Feature`
  Create a new Template that could be used to generate a feature identical to this one. The fields of the template can be edited without changing the feature.

  Specified by:
    `makeTemplate` in interface `Feature`
  Returns:
    a new Template that would make a feature like this one

### fillTemplate

    protected void fillTemplate(Feature.Template ft)

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

### realizeFeature

    public Feature realizeFeature(FeatureHolder fh,
                                  Feature.Template templ)
                           throws BioException

  Description copied from interface: `RealizingFeatureHolder`
  Realize a feature template. This will be a template which has been passed to the `createFeature` method of either this `FeatureHolder` or one of our child Features.

  Specified by:
    `realizeFeature` in interface `RealizingFeatureHolder`
  Throws:
    `BioException`

### createFeature

    public Feature createFeature(Feature.Template temp)
                          throws BioException,
                                 ChangeVetoException

  Description copied from interface: `FeatureHolder`
  Create a new Feature, and add it to this FeatureHolder. This method will generally only work on Sequences, and on some Features which have been attached to Sequences.

  Specified by:
    `createFeature` in interface `FeatureHolder`
  Throws:
    `BioException` - if something went wrong during creating the feature
    `ChangeVetoException` - if this FeatureHolder does not support creation of new features, or if the change was vetoed

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `Object`

### equals

    public boolean equals(Object o)

  Overrides:
    `equals` in class `Object`

### getSchema

    public FeatureFilter getSchema()

  Description copied from interface: `FeatureHolder`
  Return a schema-filter for this `FeatureHolder`. This is a filter which all `Feature`s immediately contained by this `FeatureHolder` will match. It need not directly match their child features, but it can (and should!) provide information about them using `FeatureFilter.OnlyChildren` filters. In cases where there is no feature hierarchy, this can be indicated by including `FeatureFilter.leaf` in the schema filter.

  For the truly non-informative case, it is possible to return `FeatureFilter.all`. However, it is almost always possible to provide slightly more information that this. For example, `Sequence` objects should, at a minimum, return `FeatureFilter.top_level`. `Feature` objects should, as a minimum, return `FeatureFilter.ByParent(new FeatureFilter.ByFeature(this))`.

  Specified by:
    `getSchema` in interface `FeatureHolder`
  Returns:
    the schema filter

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD